
#define DUMPFILE 0


//#define UNINIT_MEMDATA 0x8a
#define UNINIT_MEMDATA 0

#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/mman.h>
#include "hwaredef.h"
#include "freq.h"
#include "graphcal.h"
#include "globdef.h"
#include "llsqdef.h"
#include "netdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "blnkdef.h"
#include "vernr.h"
#include "sigdef.h"
#include "seldef.h"
#include "caldef.h"
#include "txdef.h"

#define OUTTEST_SIZE 16
#define LAST_LINE 12

extern char uninit_mem_end;
char uninit_mem_begin;




#if (USERS_EXTRA_PRESENT == 1)
float users_extra_update_interval;
#include "users_extra.c"
#endif




void prompt_reason(char *s)
{
vga_clear();
xytext(5,8,"You are prompted to the parameter selection screens");
xytext(15,10,"for the following reason:");
xytext(5,13,s);
xytext(20,16,press_any_key);
await_keyboard();
}



void check_output_no_of_channels(void)
{
int i;
i=1+((genparm[OUTPUT_MODE]>>1)&1);
if(i<ui.min_output_channels)i=ui.min_output_channels;
if(i>ui.max_output_channels)i=ui.max_output_channels;
i--;
genparm[OUTPUT_MODE]&=-3;
genparm[OUTPUT_MODE]|=i<<1;            
}



void pc_radio(void)
{
int uiparm_save[MAX_UIPARM];
char s[80],ss[80];
char *parinfo;
char *parfilnam;
int i, j, k, kmax, parwrite_flag, parfile_flag;
int *uiparm;
FILE *file;
// Save the ui parameters. We have to set channels here but some more
// changes may be done in the txtest routine.     
uiparm=(void*)(&ui);
parfilnam=NULL;
for(i=0; i<MAX_UIPARM; i++)uiparm_save[i]=uiparm[i];
if(rx_mode == MODE_TXTEST)
  {
  ui.input_mode&=-1-TWO_CHANNELS;
  ui.rx_channels=1;
  }
// Get rid of unwritten data blocks in ram
full_restart:;
fflush(NULL);
sync();
// Start by reading general parameters for the selected rx mode.
// If no parameters found, go to the parameter select routine because
// we can not guess what hardware will be in use so default parameters
// are likely to be very far from what will be needed.
parwrite_flag=0;
parfile_flag=0;
if(savefile_parname[0]!=0)
  {
  file = fopen(savefile_parname, "r");
  if (file != NULL)
    {
    parfilnam=savefile_parname;
    parfile_flag=1;
    i=fread(s,1,1,file);
    if(i == 1)
      {
      rx_mode=toupper(s[0])-'A';  
      if(rx_mode >= 0 && rx_mode <= MAX_RX_MODE)
        {    
skip_modlin:; 
        i=fread(s,1,1,file);
        if(s[0]=='\n') goto fileok;
        if(i==1)goto skip_modlin;
        }
      }
    }
  }
if(disksave_flag == 2)
  {
  get_rx_mode();
  if(savefile_parname[0]!=0)
    {
    file = fopen( savefile_parname, "r");
    if(file == NULL) parwrite_flag=1;
    }              
  }
if(parfile_flag == 0)parfilnam=rxpar_filenames[rx_mode];
file = fopen(rxpar_filenames[rx_mode], "r");
if (file == NULL)
  {
  sprintf(s,"%s file missing",rxpar_filenames[rx_mode]);
  prompt_reason(s);
iniparm:;
  for(i=0; i<MAX_GENPARM; i++)
    {
    genparm[i]=genparm_default[rx_mode][i];
    }
  genparm[MAX_GENPARM]=ui.input_speed;                                 
updparm:;
  if(disksave_flag == 4)
    {
    if(init_diskread(-1) != 0)end_program(3641);
    }
  set_general_parms(rxmodes[rx_mode]);
  genparm[MAX_GENPARM+1]=GENPARM_VERNR;
  if(savefile_parname[0]!=0)
    {
write_savefile_parms:;    
    parwrite_flag=0;
    parfilnam=savefile_parname;
    file = fopen(parfilnam, "w");
    if(file == NULL)goto wrerr;
    fprintf(file,"%c\n",rx_mode+'A');
    goto wrok;   
    }
  file = fopen(parfilnam, "w");
  if(file == NULL)
    {
  wrerr:;  
    vga_clear();
    sprintf(s,"Could not create file %s",parfilnam);
    xytext(10,10,s);
    xytext(15,12,"PRESS ANY KEY");
    while(vga_getkey() != 0);
    await_keyboard();
    end_program(0);
    }
wrok:;
  for(i=0; i<MAX_GENPARM+2; i++)
    {
    fprintf(file,"%s [%d]\n",genparm_text[i],genparm[i]);
    }
  parfile_end(file);
  file=NULL;
  }
else
  {
  parfilnam=rxpar_filenames[rx_mode];
fileok:;
  parinfo=chk_malloc(4096,1081);
  kmax=fread(parinfo,1,4095,file);
  fclose(file);
  file=NULL;
  if(kmax >= 4095)
    {
    sprintf(ss,"Excessive file size");
daterr:;    
    sprintf(s,"%s Data error in file %s",ss,parfilnam);
    prompt_reason(s);
    goto iniparm;
    }
  k=0;
  for(i=0; i<MAX_GENPARM+2; i++)
    {
    while(k <= kmax &&
          (parinfo[k]==' ' || parinfo[k]== '\n' ))k++;
    if(k > kmax)
      {
    sprintf(ss,"Premature end of file");
daterr_free:;
      parinfo=chk_free(parinfo);
      goto daterr;
      }
    j=0;
    while(parinfo[k]== genparm_text[i][j])
      {
      k++;
      j++;
      } 
    sprintf(ss,"Error: %s  ",genparm_text[i]);
    if(genparm_text[i][j] != 0 || k > kmax)
      {
      goto daterr_free;
      }
    while(k <= kmax && parinfo[k]!='[')k++;
    if(k > kmax)
      {
      goto daterr_free;
      }
    sscanf(&parinfo[k],"[%d]",&genparm[i]);
    while(k <= kmax && parinfo[k]!='\n')k++;
    if(k > kmax)
      {
      goto daterr_free;
      }
    }
  parinfo=chk_free(parinfo);
  if(disksave_flag == 4)
    {
    if(init_diskread(-1) != 0)end_program(3641);
    }
  else
    {    
    if(genparm[MAX_GENPARM] != ui.input_speed)
      {
      sprintf(s,"Input sampling speed changed %d  (old=%d)",
                                        ui.input_speed, genparm[MAX_GENPARM]);
      prompt_reason(s);
      goto iniparm;
      }                                 
    }
  if(genparm[MAX_GENPARM+1] != (int)(GENPARM_VERNR))
    {
    prompt_reason("GENPARM version changed");
    goto iniparm;
    }
  for(i=0; i<MAX_GENPARM; i++)
    {
    if(genparm[i] < genparm_min[i] || genparm[i] > genparm_max[i])
      {
illegal_value:;
      sprintf(s,"Illegal value for %s: %d (%d to %d)",genparm_text[i],
                                genparm[i],genparm_min[i], genparm_max[i]);
      prompt_reason(s);
      goto iniparm;
      }
    }
  fft1mode=(ui.input_mode&(TWO_CHANNELS+IQ_DATA))/2;
  i=fft1_version[fft1mode][genparm[FIRST_FFT_VERNR]];
  if( i < 0 || i>=MAX_FFT_VERSIONS)
    {
    prompt_reason("FFT1 version inompatible with A/D mode");
    goto iniparm;
    }  
  if(simd_present == 0)
    {
    if( fft_cntrl[i].simd != 0)
      {
      prompt_reason("Parameters say use SIMD - not supported by computer!");
      goto iniparm;
      }
    }
  if(genparm[SECOND_FFT_ENABLE] != 0)
    {  
    if(mmx_present == 0)
      {
      if( fft_cntrl[i].mmx != 0)
        {
nommx:;      
        prompt_reason("Parameters say use MMX - not supported by computer!");
        goto iniparm;
        }
      }
    i=fft1_back_version[ui.rx_channels-1][genparm[FIRST_BCKFFT_VERNR]];
    if( i < 0 || i>=MAX_FFT_VERSIONS)
      {
      prompt_reason("Backwards FFT1 version incompatible with no of channels");
      goto iniparm;
      }
    if(mmx_present == 0)
      {
      if( fft_cntrl[i].mmx != 0)goto nommx;
      }
    i=fft2_version[ui.rx_channels-1][genparm[SECOND_FFT_VERNR]];
    if( i < 0 || i>=MAX_FFT_VERSIONS)
      {
      prompt_reason("FFT2 version incompatible with no of channels");
      goto iniparm;
      }
    if(mmx_present == 0)
      {
      if( fft_cntrl[i].mmx != 0)goto nommx;
      }
// Make sure fft1_n and fft2_n are defined.
    get_buffers(1);
    k=(fft1_n-4)&0xfffe;
    if(genparm[FIRST_BCKFFT_ATT_N]>k)
      {
      i=FIRST_BCKFFT_ATT_N;
      goto illegal_value;
      }
    k=fft2_n-2;
    if(genparm[SECOND_FFT_ATT_N]>k)
      {
      i=SECOND_FFT_ATT_N;
      goto illegal_value;
      }
    }
  if(genparm[DA_OUTPUT_SPEED] > ui.max_output_speed||
            genparm[DA_OUTPUT_SPEED] < ui.min_output_speed)
    {
    sprintf(s,"Output sampling speed out of range %d  (%d to %d)",
                          genparm[DA_OUTPUT_SPEED],ui.min_output_speed,
                                                      ui.max_output_speed);
    prompt_reason(s);
    goto iniparm;
    }
  check_output_no_of_channels();
  }
if(parwrite_flag!=0)goto write_savefile_parms;    
fflush(NULL);
sync();
vga_clear();
settextcolor(7);
network_setup(0);
#if (USERS_EXTRA_PRESENT == 1)
init_users_extra();
#endif
lir_status=LIR_OK;
switch (rx_mode)
  {
  case MODE_WCW:
  case MODE_NCW:
  case MODE_HSMS:
  case MODE_SSB:
  case MODE_QRSS:
  use_bfo=1;
  wcw_rx();
  break;

  case MODE_FM:
  case MODE_AM:
  use_bfo=0;
  wcw_rx();
  break;

  case MODE_TXTEST:
  if(network_flag == 0 && disksave_flag == 0)
    {
    txtest();
    }
  else
    {
    end_program(1158);
    }  
  break;

  case MODE_ADTEST:
  test_rx();
  break;
  
  case MODE_TUNE:
  tune();
  break;

  default:
  end_program(436);
  } 
lir_errors:;
if(ui.memlock == 0)munlockall();
close_all_except_vga();
if(lir_status > LIR_OK)
  {
  if(lir_status == LIR_TUNEERR)goto skip_mode;
  vga_clear();
  xytext(5,5,"Out of memory. Try less demanding parameters");
  xytext(5,8,press_any_key);
  await_keyboard();
  goto updparm;
  }
settextcolor(7);
if(lir_status == LIR_NEW_POL)
  {
  vga_clear();
  lir_status = LIR_OK;
  goto full_restart;
  }
if(lir_status < LIR_OK)goto updparm;  
wt_kbd:;
vga_clear();
settextcolor(12);
xytext(25,1,PROGRAM_NAME);
settextcolor(15);
sprintf(s,"B = Back to %s without change",rxmodes[rx_mode]);
xytext(12,3,s);
xytext(12,4,"P = Change parameters");
xytext(12,5,"C = Calibrate frequency response");
if(ui.rx_channels == 2)xytext(12,6,"D = Select Pol. default");
settextcolor(7);
sprintf(s,"Current parameters (file: %s)",parfilnam);
xytext(2,8,s);
for(i=0; i<MAX_GENPARM+1; i++)
    {
    sprintf(s,"%s [%d] ",genparm_text[i],genparm[i]);
    if( (i+10)*text_height < HEIGHT)xytext(2,9+i, s);
    }
await_keyboard();
clean_vga_inkey();
switch (vga_inkey)
  {
  case 'B':
  goto full_restart;
  
  case 'C':
  calibrate_fft1();
  if(lir_status == LIR_OK) goto full_restart;
  goto lir_errors;

  case 'D':
  if(ui.rx_channels == 2)select_pol_default();
  break;
  
  case 'P':
  goto updparm;

  case 'X':
skip_mode:;
  for(i=0; i<MAX_UIPARM; i++)uiparm[i]=uiparm_save[i];
  return;
  }
goto wt_kbd;
}



void modify_parms(char *line1, int first, int last)
{
char s[80];
int i, j, k, m, no, mouse_line,parnum;
no=last-first+1;
start:;
hide_mouse();
vga_clear();
settextcolor(14);
xytext(5,1, line1);
// Make sure fft1_n and fft2_n are defined and 
// in agreement with current parameters.
get_buffers(1);
if( first <= DA_OUTPUT_SPEED && last >= DA_OUTPUT_SPEED)
  {
  if(genparm[DA_OUTPUT_SPEED] < ui.min_output_speed)
                              genparm[DA_OUTPUT_SPEED]=ui.min_output_speed;
  if(genparm[DA_OUTPUT_SPEED] > ui.max_output_speed)
                              genparm[DA_OUTPUT_SPEED]=ui.max_output_speed;
  if(ui.input_speed != genparm[DA_OUTPUT_SPEED] && 
            disksave_flag != 2 && network_flag != 2)
    {
    settextcolor(12);
    xytext(1,14,"WARNING input and output sampling rate different.");
    xytext(1,15,"Some old boards require the same speed setting.");
    xytext(1,16,"VIBRA 16C, MAD 16 Pro,......");
    }
  }
if( first <= CW_DECODE_ENABLE && last >= CW_DECODE_ENABLE)
  {
  if(genparm[CW_DECODE_ENABLE] != 0)
    {
    settextcolor(12);
    xytext(1,14,"WARNING: The Morse decode routines are incomplete.");
    xytext(1,15,"They will not produce any useful output and may cause");
    xytext(1,16,"a program crasch. Use only for development and perhaps");
    xytext(1,17,"for some evaluation of chirp and other keying defects");
    xytext(1,18,"with the coherent graph oscilloscope.");
    }
  }
if( first <= FIRST_BCKFFT_ATT_N && last >= FIRST_BCKFFT_ATT_N)
  {
  k=(fft1_n-4)&0xfffe;
  if(genparm[FIRST_BCKFFT_ATT_N]>k)genparm[FIRST_BCKFFT_ATT_N]=k;
  if(genparm[FIRST_BCKFFT_ATT_N]<0)genparm[FIRST_BCKFFT_ATT_N]=
                                             genparm_min[FIRST_BCKFFT_ATT_N];
  }
if( first <= SECOND_FFT_ATT_N && last >= SECOND_FFT_ATT_N)
  {
  k=fft2_n-2;
  if(genparm[SECOND_FFT_ATT_N]>k)genparm[SECOND_FFT_ATT_N]=k;
  }
settextcolor(7);
for(i=0; i<no; i++)
  {
  j=i+first;
  sprintf(s,"%s [%d] ",genparm_text[j],genparm[j]);
  xytext(1,3+i, s);
  }
xytext(1,5+no,"Use left mouse button to select line");  
xytext(1,3+no,"CONTINUE");  
settextcolor(15);
show_mouse();
modloop:;
dsp_mouse();
if(leftpressed == 2)
  {
  mouse_line=mouse_y/text_height-3;
  if(mouse_line == no)goto loopx;
  if(mouse_line >= 0 && mouse_line <no)
    {
    parnum=mouse_line+first;
    vga_clear();
    sprintf(s,"Old value = %d",genparm[parnum]);
    xytext(1,8+no, s);
    xytext(1,10+no,"Enter new value for:");
    k=genparm_max[parnum];
    m=genparm_min[parnum];
    if(parnum == FIRST_FFT_VERNR)
      {
      k=0;
      fft1mode=(ui.input_mode&(TWO_CHANNELS+IQ_DATA))/2;
      while( fft1_version[fft1mode][k+1] > 0 &&
                                  k < MAX_FFT1_VERNR-1)k++;
      if(simd_present == 0)
        {
        while( fft_cntrl[fft1_version[fft1mode][k]].simd != 0)k--;
        }
      if(mmx_present == 0)
        {
        while( fft_cntrl[fft1_version[fft1mode][k]].mmx != 0)k--;
        }
      }
    if(parnum == FIRST_BCKFFT_VERNR)
      {
      k=0;
      while( fft1_back_version[ui.rx_channels-1][k+1] > 0 &&
                                  k < MAX_FFT1_BCKVERNR-1)k++;
      if(mmx_present == 0)
        {
        while( fft_cntrl[fft1_back_version[ui.rx_channels-1][k]].mmx != 0)k--;
        }
      }
    if(parnum == FIRST_BCKFFT_ATT_N)
      {
      k=(fft1_n-4)&0xfffe;
      }
    if(parnum == SECOND_FFT_ATT_N)
      {
      k=fft2_n-2;
      }
    if(parnum == SECOND_FFT_VERNR)
      {
      k=0;
      while( fft2_version[ui.rx_channels-1][k+1] > 0 &&
                                  k < MAX_FFT2_VERNR-1)k++;
      if(mmx_present == 0)
        {
        while( fft_cntrl[fft2_version[ui.rx_channels-1][k]].mmx != 0)k--;
        }
      }
    if(parnum == MIX1_BANDWIDTH_REDUCTION_N)
      {
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        k=fft1_n-3;
        }
      else
        {
        k=fft2_n-3;
        }  
      }
    if(parnum == DA_OUTPUT_SPEED)
      {
      m=ui.min_output_speed;
      k=ui.max_output_speed;
      }
    if(parnum == MAX_NO_OF_SPURS)
      {
      if(genparm[AFC_ENABLE]==0)
        {
        k=0;
        }
      else
        {  
        if(genparm[SECOND_FFT_ENABLE] == 0)
          {
          k=fft1_size/SPUR_WIDTH;
          }
        else
          {
          k=fft2_size/SPUR_WIDTH;
          }
        }  
      }
    if(parnum == SPUR_TIMECONSTANT)
      {
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        k=5*genparm[FFT1_STORAGE_TIME];
        }
      else
        {
        k=5*genparm[FFT2_STORAGE_TIME];
        }
      }
// In case fft sizes are not set. 
    if(k < m || m<genparm_min[parnum] || k>genparm_max[parnum])
      { 
      k=genparm_max[parnum];
      m=genparm_min[parnum];
      }
    sprintf(s," %s (%d to %d)",genparm_text[parnum], m,k);
    xytext(1,11+no, s);
    genparm[parnum]=vga_get_integer(10, 13+no, 8, m,k);
    leftpressed=0;
    if(parnum == OUTPUT_MODE)check_output_no_of_channels();
    goto start;
    }
  leftpressed=0;
  }
vga_inkey=vga_getkey();
if(vga_inkey != 0)clean_vga_inkey();
if(vga_inkey == F1_KEY)
  {
  mouse_line=mouse_y/text_height-3;
  if(mouse_line >= 0 && mouse_line <no)
    {
    help_message(201+mouse_line+first);
    }
  else
    {
    help_message(200);
    }
  }
if(vga_inkey != 10 && vga_inkey!= 'X')goto modloop;
loopx:;
}



void set_general_parms(char *mode)
{
char s[80];
open_mouse();
sprintf(s,"Set parameters for mode: %s  Rx channels: %d",mode,ui.rx_channels);
setfft1:;
lir_status=LIR_OK;
close_audio_input();
close_audio_output();
modify_parms(s, 0, SECOND_FFT_ENABLE);
if(vga_inkey == 'X')goto sgx;
if(disksave_flag < 2 && network_flag != 2)
  {
  check_fft1();
  if(lir_status != LIR_OK)goto bufreduce;
  }
else
  {
// Make sure fft1_n and fft2_n are defined.
  get_buffers(1);
  }
if(genparm[SECOND_FFT_ENABLE]==1)
  {
  modify_parms(s, FIRST_BCKFFT_VERNR, FFT2_STORAGE_TIME);
  check_fft2();
  if(lir_status != LIR_OK)
    {
bufreduce:;
    vga_clear();
    if(ui.memlock == 0)munlockall();
    settextcolor(15);
    switch (lir_status)
      {
      case LIR_FFT1ERR:
      xytext(5,5,"Out of memory !!!");
      xytext(10,10,"Storage times are set to minimum.");
      settextcolor(14);
      xytext(10,13,"Check memory allocations in waterfall window");
      xytext(10,14,"to decide how much you may increase storage times.");
      genparm[FFT1_STORAGE_TIME]=genparm_min[FFT1_STORAGE_TIME];
      genparm[FFT2_STORAGE_TIME]=genparm_min[FFT2_STORAGE_TIME];
      break;
      
      case LIR_SPURERR:
      xytext(7,7,"Storage time too short for spur removal");
      xytext(7,8,"Spur removal disabled");
      genparm[MAX_NO_OF_SPURS]=0;
      break;

      case LIR_SPEEDERR:
      case LIR_NEW_SETTINGS:
      goto setfft1;
      }      
    settextcolor(7);
    xytext(10,17,"Press ESC to quit, any other key to continue");
    await_keyboard();
    clean_vga_inkey();
    goto setfft1;
    }
  }
if(vga_inkey == 'X')goto sgx;
modify_parms(s, AFC_ENABLE, AFC_ENABLE);
if(vga_inkey == 'X')goto sgx;
if(genparm[AFC_ENABLE]==1)modify_parms(s, AFC_ENABLE+1, SPUR_TIMECONSTANT);
if(vga_inkey == 'X')goto sgx;
modify_parms(s, MIX1_BANDWIDTH_REDUCTION_N, MAX_GENPARM-1);
if(vga_inkey == 'X')goto sgx;
vga_clear();
sgx:;
if(mouse_flag != 0) close_mouse();
}

void mmxerr(void)
{
printf("\n\nCould not read file /proc/cpuinfo (flags:)");
printf("\nSetting MMX and SIMD flags from hardware");
printf("\nProgram may fail if kernel support is missing and modes"); 
printf("\nneeding MMX or SIMD are selected.");
printf("\n\nPress any key");
getchar();
}


void global_uiparms(void)
{
char s[80];
int i, j, ia, ib, im, confsize;
int old_mouse, new_mouse, line, mline;
float t1, t2;
FILE *vgafile;
char *buf;
char chr;
char *mousedef={"# mouse "};
char *horsync={"HorizSync "};
char *vertsync={"VertRefresh "};
char mousenames[64][16];
clearscreen();
printf("\n\n    *W A R N I N G*  Read z_MLOCK.txt for info. \
\n    *** mlockall can cause system crashes!! *** \
\n As an alternative, use console cmd:'swapoff -a' \
\n to protect Linrad from being swapped to disk.");
printf("\n\nUse mlockall to prevent swapping? \n\n(Y/N) =>");
gtswap:;
chr=toupper(getchar());
if(chr == 'N')
  {
  ui.memlock=1;
  }
else
  {
  if(chr != 'Y')goto gtswap;
  if(mlockall(MCL_CURRENT) != 0)
    {
    if(errno == EPERM)end_program(1168);
    if(errno == ENOMEM)end_program(1169);
    end_program(1170); 
    }
  }  
clearscreen();
printf("Use usleep when the CPU is not needed\nRead z_USLEEP.txt for info.");
printf("\n(Preferred choice: 'N')\n\n(Y/N) =>");
gtsleep:;
chr=toupper(getchar());
if(chr == 'N')
  {
  ui.sleep=1;
  }
else
  {
  if(chr != 'Y')goto gtsleep;
  }  
// Open the configuration file for svgalib to give newcomers an
// easy way to make simple changes.
// First locate all mouse types by looking for "# mouse "
// and allow the user to select one of the alternatives.
clearscreen();
printf("Do you want to change monitor or mouse configuration");
printf("\nas specified in /etc/vga/libvga.config?\n(Y/N)=>");
chg:;
chr=toupper(getchar());
if(chr == 'N')goto mousered;
if(chr != 'Y')goto chg;
vgafile=fopen("/etc/vga/libvga.config","r");
if(vgafile == NULL)end_program(1195);
clearscreen();
buf=malloc(100000);
if(buf == NULL)end_program(1239);
confsize=fread(buf,1,100000,vgafile);
fclose(vgafile);
if(confsize < 4000 || confsize > 99000)end_program(1196);
buf[confsize]=10;
ia=0;
ib=0;
im=0;
line=0;
mline=0;
get_mice:;
while(buf[ia] != 10 )ia++;
while(buf[ia] == 10 || buf[ia] == 9 || buf[ia] == ' ')ia++;
line++;
if(im > 2 && line-mline>2)goto allmice;
if(ia >= confsize)goto globui_x;
i=0;
while(i < 8)
  {
  if(mousedef[i] != buf[ia])goto get_mice;
  i++;
  ia++;
  }
while(buf[ia] == 32)ia++;  
for(i=0; i<15; i++)
  {
  chr=buf[ia+i];
  if(chr == 9 || chr == ' ' || chr == '#')chr=0;
  mousenames[im][i]=chr;
  }
mousenames[im][16]=0;
mline=line;
im++;
ib=ia; 
goto get_mice;
allmice:;
// Now look for the currently defined mouse.
while(buf[ib] != 10 && buf[ib] != 13)ib++;
ia=ib;
while(ib-ia < 100 )
  {
  i=2;
  while(i < 8)
    {
    if(mousedef[i] != buf[ib])goto mfail;
    i++;
    ib++;
    }
  goto mok;
  mfail:;
  ib++;
  }  
mok:;
for(old_mouse=0; old_mouse<im; old_mouse++)
  {
  j=0;
  ia=ib;
  while(mousenames[old_mouse][j]!=0 && 
                          mousenames[old_mouse][j] == buf[ia+j])j++;
  if(mousenames[old_mouse][j]==0 && (buf[ia+j] == 10 || buf[ia+j]==13 ||
                      buf[ia+j]==13 || buf[ia+j]==9 || buf[ia+j]=='#' ||
                                               buf[ia+j]==' '))goto oldok;
  }                  
old_mouse=im;
for(i=0; i<15; i++)
  {
  chr=buf[ia+i];
  if(chr == 9 || chr == ' ' || chr == '#')chr=0;
  mousenames[im][i]=chr;
  }
mousenames[im][16]=0;
im++;    
oldok:;
for(i=0;i<im;i++)printf("\nMouse: %02d %s",i, mousenames[i]);
selmouse:;
printf("\n\n\nCurrent mouse is %s ",mousenames[old_mouse]);  
printf("\nSelect a new mouse type by line number: ");
scanf("%d",&new_mouse);
if(new_mouse<0 || new_mouse>=im)
  {
  printf(" ERROR");
  goto selmouse;
  }
chr=toupper(getchar());
// Now that we know what the user wants and where the old mouse
// was defined, store the new mouse type at the same place.
i=0;
while(mousenames[new_mouse][i] != 0)i++;
j=0;
while(mousenames[old_mouse][j] != 0)j++;
if(j>=i)
  {
  while(j>0)
    {
    buf[ia+j]=' ';
    j--;
    }
  }
else
  {
  j=i-j;
  confsize+=j;
  ib=confsize-1;
  while(ib > ia)
    {
    buf[ib]=buf[ib-j];
    ib--;
    }
  }      
j=0;
while(j<i)
  {
  buf[ia+j]=mousenames[new_mouse][j];
  j++;
  }
buf[ia+i]=10;
// Now look for sync rates.
while(ia < confsize)
  {
  for(i=0; i<10; i++)if(horsync[i] != buf[ia+i])goto hor1;
  ib=ia-1;
  while(buf[ib]==9 || buf[ib]==' ')ib--;
  if(buf[ib]==10)goto hor2;
hor1:;
  ia++;
  }
printf("\nERROR %s not found",horsync);
chr=toupper(getchar());
goto globui_x;  
hor2:;
ia+=10;
sscanf(&buf[ia],"%f  %f",&t1,&t2);
printf("\n\nCurrent %s is %.3f %.3f",horsync,t1,t2);
printf("\nEnter nev values separated by a blank\n=>");
scanf("%f  %f",&t1,&t2);
sprintf(s,"%.3f %.3f",t1,t2);
i=0; 
while(s[i] != 0)i++;
j=0;
while(buf[ia+j] != 10)
  {
  buf[ia+j]=' ';
  j++;
  }
if(i>j)
  {
  j=i-j;
  confsize+=j;
  ib=confsize-1;
  while(ib > ia)
    {
    buf[ib]=buf[ib-j];
    ib--;
    }
  }
while(i>0)
  {
  i--;
  buf[ia+i]=s[i];
  }    
//char *vertsync={"VertRefresh "};
while(ia < confsize)
  {
  for(i=0; i<12; i++)if(vertsync[i] != buf[ia+i])goto vert1;
  ib=ia-1;
  while(buf[ib]==9 || buf[ib]==' ')ib--;
  if(buf[ib]==10)goto vert2;
vert1:;
  ia++;
  }
printf("\nERROR %s not found",vertsync);
chr=toupper(getchar());
goto globui_x;  
vert2:;
ia+=12;
sscanf(&buf[ia],"%f  %f",&t1,&t2);
printf("\n\nCurrent %s is %.3f %.3f",vertsync,t1,t2);
printf("\nEnter nev values separated by a blank\n=>");
scanf("%f  %f",&t1,&t2);
sprintf(s,"%.3f %.3f",t1,t2);
i=0; 
while(s[i] != 0)i++;
j=0;
while(buf[ia+j] != 10)
  {
  buf[ia+j]=' ';
  j++;
  }
if(i>j)
  {
  j=i-j;
  confsize+=j;
  ib=confsize-1;
  while(ib > ia)
    {
    buf[ib]=buf[ib-j];
    ib--;
    }
  }
while(i>0)
  {
  i--;
  buf[ia+i]=s[i];
  }    
vgafile=fopen("/etc/vga/libvga.config","w");
fwrite(buf,1,confsize,vgafile);
vga_init();
globui_x:;
fclose(vgafile);
fflush(NULL);
sync();
free(buf);
mousered:;
printf("\n\nEnter mouse speed reduction factor:\n=>");
gtm:;
scanf("%d", &ui.mouse_speed);
getchar();
if (ui.mouse_speed < 1 || ui.mouse_speed > 1000)
  {
  printf("Error: Factor out of range\n\n");
  goto gtm;
  }
}

int main(int argc, char *argv[])
{
int message_line;
char *parinfo;
int i,j,k,mmx1,simd1,xxprint;
char chr,s[256];
FILE *file;
char *flags="flags";
char *fmmx=" mmx";
char *fsse=" sse";
char *z;
int *uiparm;
uiparm=(void*)(&ui);
// Make silly use of parameters to suppress warning
chr=argv[0][0];
i=argc;
// put something nonzero in scratch memory to make sure we not rely on 
// it being zero when starting.
z=(void*)(&uninit_mem_begin);
k=&uninit_mem_end-&uninit_mem_begin;
if(UNINIT_MEMDATA != 0)
  {
  for(i=0; i<k; i++)z[i]=UNINIT_MEMDATA;
  }
if(DUMPFILE)
  {
  dmp = fopen("dmp", "w");
  if(dmp!=NULL)PERMDEB"\n******************************\n");
  }
else
  {  
  dmp=NULL;
  }
// Make sure we know that no memory space is reserved.
wg_waterf=NULL;
bg_waterf=NULL;
fft3_handle=NULL;
hires_handle=NULL;
fft1_handle=NULL;
blanker_handle=NULL;
baseband_handle=NULL;
afc_handle=NULL;
da_wrbuf=NULL;
vga_font=NULL;
dx=NULL;
// and that analog io is closed
audio_in=-1;
audio_out=-1;
daout_block=0;
tx_audio_in=-1;
tx_audio_out=-1;
tx_flag=0;
// Clear flags
mouse_flag=0;
graphics_flag=0;
vga_init();
vga_setmode(TEXT);
// If there is no mmx, do not use simd either.
i=check_mmx();
xxprint=0;
mmx1=0;
simd1=0;
mmx_present=i&1;
if(mmx_present != 0)simd_present=i/2; else simd_present=0;
if(i!=0)
  {
  file = fopen("/proc/cpuinfo", "r");
  if (file == NULL)
    {
    mmxerr();
    }
  else
    {
nxline:;
    if(fgets(s,256,file)==NULL)
      {
      mmxerr();
      }
    else
      {  
      k=0;
      while(s[k] != flags[0] && k < 10)k++;
      for(i=0; i<5; i++) if(s[i+k]!=flags[i])goto nxline; 
      k+=5;  
nxbln:      
      while(s[k]!=0 && s[k]!=' ')k++;
      while(s[k]!=0 && s[k]==' ')k++;
      if(s[k]!=0)
        {
        k--;
        for(i=0; i<4; i++)if(s[i+k]!=fmmx[i])goto notmmx;
        if(s[k+4] != ' ' && s[k+4] != 10)goto notmmx;
        mmx1=1;
notmmx:;      
        for(i=0; i<4; i++)if(s[i+k]!=fsse[i])goto notsse;
        if(s[k+4] != ' ' && s[k+4] != 10)goto notsse;
        simd1=1;
notsse:;
        k++;
        goto nxbln;
        }      
      xxprint=1;
      }
    fclose(file);
    file=NULL;
    }
  }  
allow_parport=0;
users_open_devices();
main_reinit:;
sync();
file = fopen(userint_filename, "rb");
if (file == NULL)
  {
  if(xxprint != 0)
    {
    i=0;
    if(mmx1==0)
      {
      i=1;
      printf("\nMMX supported by hardware");
      }
    if(simd1==0 && simd_present != 0)
      {
      i=1;
      printf("\nSIMD (=sse) supported by hardware");
      }
    if(i!=0)
      {
      printf("\n/proc/cpuinfo says LINUX core is not compatible.");
      printf(
           "\n\nLinrad will allow you to select routines that may be illegal");
      printf("\non your system.");
      printf("\nAny illegal instruction will cause a program crasch!!");
      printf("\nSeems just the sse flag in /proc/cpuinfo is missing.");
      printf("\nTo use fast routines with an older core, recompile LINUX");
      printf("\nwith appropriate patches.\n\n");
      }
    }
  printf("\nSetup file %s missing.",userint_filename);
full_setup:;
  for(i=0; i<MAX_UIPARM; i++) uiparm[i]=0;
  printf("\nUse W to create a new %s file after setup.",userint_filename);
  printf("\n\nPress S for setup routines");
  printf("\nAny other key to exit");
  printf("\nThen press enter\n\n=>"); 
  chr=toupper(getchar());
  if(chr != 'S') exit(0);
  clearscreen();
  global_uiparms();
  set_vgamode();
  ui.input_mode=-1;
  }
else
  {
  parinfo=chk_malloc(4096,1078);
  i=fread(parinfo,1,4095,file);
  fclose(file);
  file=NULL;
  if(i >= 4095)
    {
    goto full_setup;
    }
  k=0;
  for(i=0; i<MAX_UIPARM; i++)
    {
    while(parinfo[k]==' ' ||
          parinfo[k]== '\n' )k++;
    j=0;
    while(parinfo[k]== uiparm_text[i][j])
      {
      k++;
      j++;
      } 
    if(uiparm_text[i][j] != 0)goto full_setup;
    while(parinfo[k]!='[')k++;
    sscanf(&parinfo[k],"[%d]",&uiparm[i]);
    while(parinfo[k]!='\n')k++;
    }
  if(ui.check != UI_VERNR)
    {
    printf("\nWrong version for setup file %s",userint_filename);
    parinfo=chk_free(parinfo);
    goto full_setup;
    }
  }
if (vga_hasmode(ui.vga_mode)==0)goto full_setup;
new_grmode:;
vga_setmode(ui.vga_mode);
graphics_flag=1;
gl_setcontextvga(ui.vga_mode);
for(i=0; i<256;i++)
  {
  gl_setpalettecolor(i, svga_palette[3*i+2],
                        svga_palette[3*i+1],
                        svga_palette[3*i  ]);
  }
init_font();
eme_flag=0;
network_flag=0;
read_eme_database();
fflush(NULL);
sync();
usleep(30000);
// vga_setmousesupport(1);
mouse_init("/dev/mouse",vga_getmousetype(),MOUSE_DEFAULTSAMPLERATE);
mouse_setdefaulteventhandler();
main_loop:;
vga_clear();
settextcolor(12);
xytext(21,0,PROGRAM_NAME);
settextcolor(7);
button_color=7;
if(network_flag == 2)xytext(10,0,"NETWORK MODE");
for(i=0; i<MAX_RX_MODE; i++)
  {
  sprintf(s,"%c=%s",i+'A',rxmodes[i]);
  xytext(0, i+2,s);
  }
i=SETUP_LINE;
if(network_flag != 2)
  {
  xytext(30,2,"1=Process first file named in 'adfile'");
  xytext(30,3,"2=Process first file named in 'adwav'");
  xytext(30,4,"3=Select file from 'adfile'");
  xytext(30,5,"4=Select file from 'adwav'");
  xytext(30,6,"R=Toggle network input");
  settextcolor(3);
  xytext(0, i  , "M=Init moon tracking and EME database");
  i++;
  xytext(0, i, "N=Network set up");
  i++;
  xytext(0, i, "S=Screen set up");
  i++;
  xytext(0, i, "T=Global parameters set up");
  i++;
  xytext(0, i, "U=A/D and D/A set up for RX");
  i++;
  xytext(0, i, "V=TX mode set up");
  i++;
  xytext(0, i, "W=Save current parameters in par_userint");
  i++;
  xytext(0, i, "Z=Hardware interface test");
  i++;
  xytext(0, i, "F1=Show keyboard commands");
  i++;
  }
xytext(0, i, "ESC=Quit program");
message_line=i+1;
settextcolor(7);
vga_inkey=vga_getkey();
while(vga_inkey != 0)vga_inkey=vga_getkey();
await_keyboard();
select_mainfunc:;
sync();
savefile_parname[0]=0;
wav_read_flag=0;
calibrate_flag=0;
disksave_flag=0;
vga_inkey=toupper(vga_inkey);
if(network_flag != 2)
  {
  switch ( vga_inkey )
    {
    case '1':
    case '3':
    if(init_diskread(vga_inkey-'1') == 0) pc_radio();
    goto main_reinit;
    break;

    case '2':
    case '4':
    wav_read_flag=1;
    if(init_diskread(vga_inkey-'2') == 0) pc_radio();
    goto main_reinit;
    break;

    case 'N':
    network_setup(1);
    break;

    case 'S':
    set_vgamode();
    goto new_grmode;
    break;

    case 'T':
    vga_setmode(TEXT);
    graphics_flag=0;
    global_uiparms();
    goto new_grmode;

    case 'U':
setad:;
    set_analog_io();
    if(vga_inkey == 'W')goto save_ui;
    break; 

    case 'V':
    tx_setup();
    break; 

    case 'W':
save_ui:;  
    file = fopen(userint_filename, "w");
    if (file == NULL)
      {
      close_all();
      clearscreen();
      printf("Failed to open/create %s\n\n",userint_filename);
      end_program(10);
      }
    ui.check=UI_VERNR;  
    for(i=0; i<MAX_UIPARM; i++)
      {
      fprintf(file,"%s [%d]\n",uiparm_text[i],uiparm[i]);
      }
    parfile_end(file);
    file=NULL;
    settextcolor(15);
    xytext(0, message_line, "User interface setup saved");
    for(i=0; i<MAX_UIPARM-1; i++)
      {
      sprintf(s,"%s [%d] ",uiparm_text[i],uiparm[i]);
      if( (message_line+i+1)*text_height < HEIGHT)xytext(29,message_line+i, s);
      }
    await_keyboard();
    clean_vga_inkey();
    goto select_mainfunc;

    case 'Z':
    hware_interface_test();
    break;
    }
  }   
switch ( vga_inkey )
  {
  case 'R':
  network_flag^=2;
  break;
  
  case 'M':
  init_eme_database();
  break;

  case F1_KEY:
  help_message(1);
  break;

  default:
  if(ui.input_mode == -1)goto setad;
  rx_mode=(vga_inkey-'A');
  if( rx_mode >=0 && rx_mode<MAX_RX_MODE)pc_radio();
  break;
  }
goto main_loop;
}

